Bug 614028 - invalid backtraces by gdb 7.0.1-23.el5
invalid backtraces by gdb 7.0.1-23.el5
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: gdb (Show other bugs)
5.5
x86_64 Linux
low Severity high
: rc
: ---
Assigned To: Jan Kratochvil
qe-baseos-tools
: Regression
Depends On:
Blocks: 614601 614604
  Show dependency treegraph
 
Reported: 2010-07-13 10:25 EDT by Florian Schlechtleitner
Modified: 2011-05-13 08:45 EDT (History)
3 users (show)

See Also:
Fixed In Version: gdb-7.0.1-26.el5
Doc Type: Bug Fix
Doc Text:
GDB could have failed to backtrace some functions of binary files. This occurred when some of the source files of a single binary file were compiled with debug information (gcc -g), and some without it. With this update, GDB finds all Call Frame Information (CFI) present in the binary file and backtraces correctly.
Story Points: ---
Clone Of:
: 614601 614604 (view as bug list)
Environment:
Last Closed: 2011-01-13 18:54:57 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Old Backtrace, New Backtrace and Binary to reproduce (256.30 KB, application/zip)
2010-07-13 10:25 EDT, Florian Schlechtleitner
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2011:0099 normal SHIPPED_LIVE gdb bug fix update 2011-01-12 12:21:16 EST

  None (edit)
Description Florian Schlechtleitner 2010-07-13 10:25:50 EDT
Created attachment 431479 [details]
Old Backtrace, New Backtrace and Binary to reproduce

Description of problem:
gdb produces invalid backtraces.

for example stackframe of threads:
#12 0x0000000001db3818 in ?? ()
#13 0x00000000477c3c01 in ?? ()
#14 0x00000000477c3c50 in ?? ()
Cannot access memory at address 0x2f1b16068d234f5

Version-Release number of selected component (if applicable):
7.0.1-23.el5 (gdb-6.8-37.el5 - RHEL 5.4 - works perfectly)

How reproducible:
(Attachment)

Steps to Reproduce:
1. Call Binary "BinaryToReproduce"
2. Binary will crash automatically with signal 6
3. Analyze coredump with gdb - following steps:
3.1 bt
3.2 info threads
3.3 thread apply all backtrace


  
Actual results:
see gdb.BinaryToReproduce_7.0.1-23.el5.txt in attached zip-archive.

Expected results:
see gdb.BinaryToReproduce_gdb-6.8-37.el5.txt in attached zip-archive.

Additional info:
Binary compliled with gcc version 4.1.2 20080704 (Red Hat 4.1.2-48).
Comment 1 Jan Kratochvil 2010-07-14 16:34:33 EDT
Fix + testcase at:
http://sourceware.org/ml/archer/2010-q3/msg00028.html

This is a regression against RHEL-5.4.
Comment 3 Markus Schmalzried 2010-07-20 08:01:46 EDT
Thanks for quickly fixing this problem.
We will verifiy it as soon as the fixed redhat rpm will be available.
Which rpm version will include the bugfix?
Comment 4 Jan Kratochvil 2010-07-20 08:13:47 EDT
Please open Issue Tracker with GSS (support services) for a possible RHEL rpm access.  Binary rpm will be available only with RHEL-5.6 in the future otherwise.
The upstream posted patch applies cleanly to the RHEL-5.5 src.rpm sources.
It will be binary built for Fedora today - but that is Bug 614604.
Comment 9 Eva Kopalova 2010-11-16 12:14:00 EST
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
GDB could have failed to backtrace some functions of binary files. This occurred when some of the source files of a single binary file were compiled with debug information (gcc -g), and some without it. With this update, GDB finds all Call Frame Information (CFI) present in the binary file and backtraces correctly.
Comment 11 errata-xmlrpc 2011-01-13 18:54:57 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-0099.html

Note You need to log in before you can comment on or make changes to this bug.